class Stasis
  module Extensions
    class ContentFor < Stasis::Plugin
      before_all :before_all
      reset :reset

      def initialize(stasis)
        @stasis = stasis
        reset
      end

      def before_all
        define_helpers
      end

      def reset
        @content = {}
      end

      protected

      def define_helpers
        @stasis.controller.helpers do
          def content_for(key, &block)
            @content ||= {}
            @content[key] ||= ""
            @content[key] << capture_haml(&block) if block_given?
            @content[key]
          end
        end
      end
    end
  end
end
